#include "stdio.h"
//
// Clase BMP, para manejo de graficos en memoria y archivos               
//
class BMP{
	unsigned int ancho,alto,reserva;
	void far *datos;
	public:
		BMP(){reserva=0;}
		~BMP(){libera();}
		void get(int,int,int,int);
		void put(int,int,int);
		void libera(){if(reserva==1)farfree(datos);reserva=0;}
		void graba(int,int,int,int,char *);
		void carga(int,int,char *);};
//***************** graba en archivo una region de pixeles *******************
void BMP::graba(int x1,int y1,int x2,int y2,char *nom){
		unsigned int an=x2-x1+1,al=y2-y1+1,i,j;FILE *fp;byte temp;
		fp=fopen(nom,"wb");mhide();
		if(fp==NULL){cout<<"No se pudo crear archivo";return;}
		fwrite(&an,sizeof(word),1,fp);
		fwrite(&al,sizeof(word),1,fp);
		for(i=y1;i<=y2;i++)
			for(j=x1;j<=x2;j++){
				temp=getpixel(j,i);fwrite(&temp,sizeof(byte),1,fp);}
		setcolor(15);rectangle(x1,y1,x2,y2);fclose(fp);mshow();}
//***************** recupera de archivo una region de pixeles ****************
void BMP::carga(int x,int y,char *nom){
		unsigned int i,j,an,al;FILE *fp;//byte temp;
		fp=fopen(nom,"rb");mhide();
		if(fp==NULL){cout<<"No se pudo abrir archivo";return;}
		fread(&an,sizeof(word),1,fp);
		fread(&al,sizeof(word),1,fp);
		for(i=0;i<al;i++)
			for(j=0;j<an;j++){
				//fread(&temp,sizeof(byte),1,fp);
				putpixel(j+x,i+y,fgetc(fp));}
		fclose(fp);mshow();}
//******************* dibuja en pantalla imagen en memoria *******************
void BMP::put(int x,int y,int op){
	if(reserva==1){mhide();putimage(x,y,datos,op);mshow();}else cout<<"No hay nada en memoria";}
//********************* captura en memoria una imagen ************************
void BMP::get(int x1,int y1,int x2,int y2){
	unsigned long int size=imagesize2(x1,y1,x2,y2);datos=farmalloc(size);
	ancho=x2-x1+1;alto=y2-y1+1;if(datos==NULL){cout<<"error reser. mem.";return;}
	mhide();getimage(x1,y1,x2,y2,datos);reserva=1;mshow();}
