// Tutor de Modo Grfico...
// Este cdigo es de dominio pblico para todos los alumnos de la
// Escuela Politcnica del Ejercito
// @2000

#if !defined(__BOTON_H)

#define __BOTON_H
#include "c:\temp\lib\mouse.h"
#include "string.h"
//*********************************************************************
///////////////////////////////////////////////////////////////////////
//************************* OBJETO BOTON ******************************
class BUTTON{
	int x,y,visible,size,press,listo,marcado;
	int tipcon,tip,tx1,tx2,ty,velotip;
	void *Bajotip;
	char *text,*textip;
	void dibuja(int);
	void ponetip();
	void quitatip();
	void foco(int);
	int dentro();
	public:
		BUTTON(int,int,int,char *,char *);
		~BUTTON();
		void velocidad(int v){velotip=v;}
		void show();
		void hide(int color);
		int verifica();
		void cambia(char *);
};
//********* cambia el texto del boton **********************************
void BUTTON::cambia(char *cad){
	delete []text;text=new char[strlen(cad)+1];strcpy(text,cad);show();}
//********* verifica si un boton ha sido presionado ********************
int BUTTON::verifica(){
	if (dentro()&&!press&&visible) if (tipcon<32000)++tipcon;
	if ((tipcon>velotip)&&(tip==0)) ponetip();
	if (dentro()&&!marcado&&visible) foco(1);
	if (!dentro()&&marcado){tipcon=0;if (tip==1)quitatip();foco(0);}
	if (mouse.click()&&visible){
		if(dentro()&&!listo){dibuja(1);sonido(0);listo=1;}
		if(!dentro()&&listo){dibuja(0);sonido(1);listo=0;}}
	else
		if (listo&&dentro()) {marcado=0;dibuja(0);listo=0;sonido(0);
		mouse.cursor(1);return(1);}
return(0);
}
//******* resplandece titulo y cambia cursor si hay foco ***************
void BUTTON::foco(int flag){
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
	if (flag==0){mouse.cursor(1);mhide();
	setcolor(0);outtextxy(x,y,text);mshow();marcado=0;}
	else{mouse.cursor(2);mhide();
	setcolor(4);outtextxy(x,y,text);mshow();marcado=1;}}
//***************** funcion que imprime tip ****************************
void BUTTON::ponetip(){
	int size;
	tx1=mouse.vx();ty=mouse.vy();ty+=27;
	tx2=tx1+(strlen(textip)*8)+5;
	if(tx2>grafo.maxx()){int dif=tx2-tx1;tx1-=dif-20;tx2-=dif-20;}
	mhide();
	size=imagesize(tx1-1,ty-1,tx2+1,ty+11);Bajotip=malloc(size);
	if(Bajotip!=NULL)getimage(tx1-1,ty-1,tx2+1,ty+11,Bajotip);
	else {cout<<"no se pudo reservar memoria para tip";return;}
	setcolor(15);
	for(int i=ty;i<=(ty+10);++i) {line(tx1,i,tx2,i);delay(2);}
	setcolor(0);
	rectangle(tx1-1,ty-1,tx2+1,ty+11);
	settextjustify(LEFT_TEXT,CENTER_TEXT);
	settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
	setcolor(1);outtextxy(tx1+2,ty+6,textip);tip=1;
	mshow();}
//***************** funcion que quita el tip ***************************
void BUTTON::quitatip(){if(tip==1){tipcon=tip=0;mhide();
	putimage(tx1-1,ty-1,Bajotip,COPY_PUT);free(Bajotip);
	Bajotip=NULL;mshow();}}
//*** funcion que comprueba si el raton esta dentro de un boton ********
int BUTTON::dentro(){
	if ((mouse.vx()>(x-(45*size)))&&(mouse.vx()<(x+(45*size)))&&
		(mouse.vy()>(y-10))&&(mouse.vy()<(y+10)))
		return(1); else return(0);}
//******************* borra el boton de la pantalla ********************
void BUTTON::hide(int color){
	mhide();setcolor(color);
	for(int i=y-10;i<=y+10;++i) line(x-(45*size),i,x+(45*size),i);
	mshow();visible=press=0;}
//********************* despliega el boton en pantalla *****************
void BUTTON::show(){visible=1;press=1;dibuja(0);press=0;tipcon=0;}
//*************** funcion constructora de boton ************************
BUTTON::BUTTON(int x1,int y1,int size1,char *cad,char *cad2){
	x=x1;y=y1;size=size1;tip=tipcon=press=listo=marcado=visible=0;
	text=new char[strlen(cad)+1];strcpy(text,cad);
	textip=new char[strlen(cad2)+1];strcpy(textip,cad2);
	Bajotip=NULL;velotip=2000;}
//****************** funcion destructora de boton **********************
BUTTON::~BUTTON(){delete[]text;delete[]textip;}
//******************** dibuja un boton *********************************
void BUTTON::dibuja(int estado){
	if ((visible==1)&&(estado!=press)){
		if (tip==1) quitatip();mhide();tipcon=-2*velotip;setcolor(7);
		for(int i=y-10;i<=y+10;++i) line(x-(45*size),i,x+(45*size),i);
		setcolor(15);rectangle(x-(45*size),y-10,x+(45*size),y+10);
		setcolor(0);
		settextjustify(CENTER_TEXT,CENTER_TEXT);
		settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
		if (estado==0){
			line(x-(45*size),y+10,x+(45*size),y+10);
			line(x+(45*size),y-10,x+(45*size),y+10);
			outtextxy(x,y,text);}
		else{
			line(x-(45*size),y-10,x+(45*size),y-10);
			line(x-(45*size),y-10,x-(45*size),y+10);
			outtextxy(x+1,y+1,text);}
		press=estado;mshow();
	}
}
#endif