// Tutor de Modo Grfico...
// Este cdigo es de dominio pblico para todos los alumnos de la
// Escuela Politcnica del Ejercito
// @2000

#if !defined(__MOUSE_H)
#define __MOUSE_H
#include "c:\temp\lib\graficos.h"
#include "alloc.h"
void mhide();
void mshow();
//********************* objeto MOUSE ***************************
class MOUSE{
	union REGS ireg;
	struct REGPACK res;
	int x,y,der,izq,ax,ay,visible,tipo_cursor,reserva;
	void far *bajo;
		void dibuja_flecha();
		void dibuja_mano();
		void quita(){if((reserva!=0)&&(visible==1)){
			putimage(ax,ay,bajo,COPY_PUT);visible=0;}}
		void pone();
	public:
		MOUSE(){bajo=NULL;reserva=visible=0;}
		~MOUSE(){if(bajo!=NULL)farfree(bajo);}
		friend void mhide();
		friend void mshow();
		void cursor(int);
		void actualiza();
		void inicia(int,int);
		void datos(int *,int *,int *,int *);
		void limites(int,int,int,int);
		int click(){return (izq);}
		int dclick(){return (der);}
		int vx(){return(x);}
		int vy(){return(y);}
};
//************** pone el cursor en pantalla ****************
void MOUSE::pone(){
	if((reserva!=0)&&(visible==0)){
		getimage(ax,ay,ax+30,ay+25,bajo);
		switch(tipo_cursor){
			case 1:dibuja_flecha();break;
			case 2:dibuja_mano();break;
		}
		visible=1;
	}
}
//****************** dibuja cursor *************************
void MOUSE::dibuja_flecha(){
	setcolor(255);
	line(x+3,y+6,x+3,y+14);line(x+4,y+8,x+4,y+13);
	line(x+5,y+10,x+5,y+14);line(x+6,y+12,x+6,y+16);
	line(x+7,y+16,x+7,y+20);line(x+8,y+20,x+8,y+22);
	setcolor(251);
	line(x+1,y+1,x+1,y+17);line(x+1,y+1,x+12,y+12);
	line(x+13,y+13,x+8,y+13);line(x+1,y+17,x+4,y+14);
	line(x+8,y+14,x+10,y+21);line(x+5,y+15,x+7,y+22);
	line(x+1,y+2,x+11,y+12);
	setcolor(253);
	line(x+2,y+4,x+2,y+15);line(x+2,y+4,x+9,y+11);
	line(x+4,y+7,x+8,y+11);line(x+5,y+9,x+7,y+11);
	putpixel(x+6,y+11,253);line(x+10,y+12,x+7,y+12);
	line(x+7,y+13,x+7,y+15);line(x+8,y+16,x+8,y+19);
	putpixel(x+9,y+20,253);
	setcolor(249);
	line(x,y,x,y+19);line(x+1,y,x+14,y+13);
	line(x,y+19,x+4,y+15);line(x+14,y+14,x+9,y+14);
	line(x+4,y+15,x+6,y+22);line(x+9,y+14,x+11,y+21);
	line(x+6,y+22,x+11,y+21);
}
//********************** dibuja mano ********************************
void MOUSE::dibuja_mano(){
	setcolor(254);
	for(int i=x+3;i<x+24;i++)line(i,y+14,i,y+22);
	setcolor(252);line(x+5,y+24,x+20,y+24);setcolor(253);
	line(x+3,y+23,x+23,y+23);line(x+8,y+14,x+9,y+14);
	line(x+13,y+14,x+14,y+14);line(x+18,y+14,x+19,y+14);
	for(i=1;i<5;i++){
		setcolor(256-i);
		line(x+i,y+14,x+i,y+22-i);line(x+4+i,y+1,x+4+i,y+17-i);
		line(x+9+i,y+8,x+9+i,y+17-i);line(x+14+i,y+8,x+14+i,y+17-i);}
	for(i=1;i<3;i++){
		setcolor(256-i);line(x+19+i,y+8,x+19+i,y+17-i);
		setcolor(254-i);line(x+21+i,y+8,x+21+i,y+23);}
	putpixel(x+21,y+22,253);putpixel(x+22,y+23,252);
	putpixel(x+3,y+22,253);setcolor(249);
	line(x+1,y+21,x+2,y+23);line(x+2,y+23,x+6,y+25);
	line(x+7,y+25,x+19,y+25);line(x+23,y+23,x+20,y+25);
	line(x,y+14,x,y+20);line(x+1,y+13,x+3,y+13);
	line(x+4,y+2,x+4,y+17);line(x+5,y+1,x+6,y);
	line(x+7,y,x+8,y+1);line(x+9,y+2,x+9,y+13);
	line(x+10,y+8,x+11,y+7);line(x+12,y+7,x+13,y+8);
	line(x+14,y+9,x+14,y+13);line(x+15,y+8,x+16,y+7);
	line(x+17,y+7,x+18,y+8);line(x+19,y+9,x+19,y+13);
	line(x+20,y+8,x+21,y+7);line(x+22,y+7,x+23,y+8);
	line(x+24,y+9,x+24,y+22);
}
//****** funcion que cambia los limites de accion del mouse *****
void MOUSE::limites(int limx1,int limy1,int limx2, int limy2){
	quita();
	ireg.x.ax=7;
	ireg.x.cx=limx1;
	ireg.x.dx=limx2;
	int86(0x33, &ireg, &ireg);
	ireg.x.ax=8;
	ireg.x.cx=limy1;
	ireg.x.dx=limy2;
	int86(0x33, &ireg, &ireg);
	pone();
}
//************** devuelve datos en punteros ********************
void MOUSE::datos(int *x1,int *y1,int *izq1,int *der1){
	*x1=x;*y1=y;*izq1=izq;*der1=der;
}
//************** cambia puntero del mouse **********************
void MOUSE::cursor(int mask){
	if(mask!=tipo_cursor&&mask>0&&mask<3){
		quita();tipo_cursor=mask;pone();
	}
}
//***** actualiza la posicion actual del raton y botones *******
void MOUSE::actualiza(){
	res.r_ax=3;intr(0x33,&res);izq=res.r_bx&0x01;
	der = res.r_bx & 0x02;der = der >> 1;x = res.r_cx ;y = res.r_dx;
	if((x!=ax)||(y!=ay)){
		quita();ax=x;ay=y;pone();
	}
}
//************* funcion para inicializar el raton ****************
void MOUSE::inicia(int lx,int ly) {
	ireg.x.ax=0;
	int86(0x33, &ireg, &ireg);
	ireg.x.ax = 4;
	ireg.x.cx = lx;
	ireg.x.dx = ly;
	int86(0x33, &ireg, &ireg);
	bajo=farmalloc(imagesize2(100,100,130,125));
	if(bajo==NULL){closegraph();
		cout<<"No se pudo reservar memoria para mouse";exit(1);
	}
	ax=x=lx;ay=y=ly;visible=0;tipo_cursor=1;reserva=1;
	limites(1,1,grafo.maxx()-31,grafo.maxy()-2);
	pone();
}
//***************************************************************************
MOUSE mouse; // define objeto mouse global
//**************************************************************************
void mhide(){
	mouse.quita();
}
void mshow(){
	mouse.pone();
}
#endif