#if !defined(__GRAFICOS_H)
#define __GRAFICOS_H
#include "graphics.h"
#include "conio.h"
#include "iostream.h"
#include "stdlib.h"
#include "dos.h"
#include "stdio.h"
//****************************************************************************
int huge detectar(void);
/////////////////////////////////////////////////////////////////////////////
//******************* objeto GRAFICOS *****************************************
class GRAFICOS{
	int GraphDriver,GraphMode,ErrorCode;
	static int modosugerido,vmaxx,vmaxy;
	public:
		friend int huge detectar(void);
		~GRAFICOS();
		static int maxx(){return(vmaxx);}
		static int maxy(){return(vmaxy);}
		void open(int);
};
//**************************************************************************
int GRAFICOS::modosugerido;
int GRAFICOS::vmaxx=0;
int GRAFICOS::vmaxy=0;
//******************* cierra el modo grafico y limpia pantalla ***************
GRAFICOS::~GRAFICOS(){
	closegraph();textcolor(7);textbackground(0);clrscr();}
//****************** inicializa modo grafico *********************************
void GRAFICOS::open(int res){//modo=0 EGAVGA,modo!=0 SVGA256; res[0-4]
	if ((res<0)||(res>4)) {cout<<"Resolucion inexistente";return;}
	modosugerido=res;//RESOLUCIONES: 0=320x200; 1=640x400; 2=640x480; 3=800x600; 4=1024x768
	GraphDriver = installuserdriver("SVGA256",detectar); //instala SVGA256.bgi
	GraphDriver = DETECT; 		/* Request auto-detection	*/
	initgraph( &GraphDriver, &GraphMode,"c:/temp/bgi");
	ErrorCode = graphresult();		/* Read result of initialization*/
	if( ErrorCode != grOk ){		/* Error occured during init	*/
	cout<<" Error en Sistema Grafico: "<<grapherrormsg( ErrorCode );getch();exit(1);}
	vmaxx=getmaxx();vmaxy=getmaxy();
}
//***********************funcion para ayudar a instalar driver ***************
int huge detectar(void){
	return (GRAFICOS::modosugerido);
}
//**************************************************************************
GRAFICOS grafo; //define objeto global
//***************************************************************************

//*********************** mide el tamao de alocacion de memoria ************
unsigned long int imagesize2(int x,int y,int x2,int y2){
	unsigned long int lx,ly,lx2,ly2,salida;
	lx=(unsigned long int) x;ly=(unsigned long int) y;
	lx2=(unsigned long int) x2;ly2=(unsigned long int) y2;
	salida=(lx2-lx+1)*(ly2-ly+1);return(salida);}
//******************** funcion que emite clicks *****************************
void sonido(int i){
	if (i==0){sound(30);delay(10);nosound();}
		else{sound(20);delay(10);nosound();}
}
#endif
